#==============================================================================
# package      DE_EPAGES::Product::API::Constants
# state        public
#------------------------------------------------------------------------------
# description  Some constants
#==============================================================================
package DE_EPAGES::Product::API::Constants;
use base Exporter;

use strict;
our @EXPORT_OK = qw(
    CSV_SPECIAL_PRODUCTITEMS
    CSV_SPECIAL_PRODUCTITEMS_UNITY_EXP
    CSV_SPECIAL_PRODUCTITEMS_UNITY_IMP
    CSV_WARNING_CODES_PRODUCT
    CSV_WARNING_CODES_PRODUCTTYPE
    FROM_MASTERPRODUCT_INHERITABLE_ATTRIBUTES_ON_UPDATE
    FROM_MASTERPRODUCT_NON_INHERITABLE_ATTRIBUTES_ON_GETWITHPARENT
    UNITY_ATTRIBUTES_FROM_MASTERPRODUCT_WRITTEN_ON_SUBS_ON_CREATE
    UNITY_LOC_ATTRIBUTES_FROM_MASTERPRODUCT_WRITTEN_ON_SUBS_ON_CREATE
    UNITY_NOT_UPDATE_ATTRIBUTES_ON_SUBS_ON_UPDATE_MASTER
    UNITY_CSV_ATTRIBUTEVALUES_NOT_FOR_SUBPRODUCTS
    UNITY_IMAGE_ATTRIBUTES
    UNITY_PRODUCT_TYPE_ATTRIBUTES_IGNORE
    UNITY_INHERITABLE_ATTRIBUTES

    PRODUCT_PAGETYPE
    PRODUCT_ATTRIBUTE_TYPES
    PRODUCT_IMAGES_JPEG_QUALITIES
    PRODUCT_IMAGES_SIZES
    PRODUCT_LARGE_IMAGE_SIZES
    PRODUCT_IMAGE_SIZE_NAMES
    PRODUCT_IMAGE_MAX_COUNT

    SMART_PRODUCT_SEARCH_RESULT_COUNT

    CONVERSION_FACTOR_BYTE

    PRODUCT_ATTRIBUTE_DEPENDENCY
    MBOUI_PRODUCT_DETAIL_PAGE

    VIMEO_API_URL

    UNITY_CUSTOMIZABLE_HEADLINELENGTH

    UNITY_CUSTOMIZABLE_DEFAULTTEXTLENGTH
);

## no critic qw(ProhibitLongLines)

#========================================================================================
# global       $CSV_SPECIAL_PRODUCTITEMS | csv export import constants <ul>
#                   <li>0 - do not export this attributes</li>
#                   <li>1 - export this attributes, also if not exportable</li>
#               </ul> | ref.array.string
#========================================================================================
use constant CSV_SPECIAL_PRODUCTITEMS => {
    0 => [ qw( GUID Inherit CreationDate Site Date
               NavigationCaption VisibleInNavigation
               IsAppointment CanPayAppointment DurationAmount DurationUnit PriceListValues RatingAverage
               AmazonListerID AmazonCondition AmazonDeliveryLatency DownloadProductMaps PrepaymentType PrepaymentValue
               IsCustomizable CustomizeAreaAllowPositioning CustomizeAreaAllowRotation CustomizeAreaAllowScaling CustomizeShowPreview CustomizeDescription

         ) ],
    1 => [ qw( Class ListPrices SuperProduct SelectedVariations ManufacturerPrices ShippingMethods EcoParticipations Deposits) ],
};

#========================================================================================
# global       CSV_SPECIAL_PRODUCTITEMS_UNITY_EXP | csv export constants for unity shops <ul>
#                   <li>0 - do not export this attributes</li>
#                   <li>1 - export this attributes, also if not exportable</li>
#               </ul> | ref.array.string
#========================================================================================
use constant CSV_SPECIAL_PRODUCTITEMS_UNITY_EXP => {
    0 => [ qw( GUID Inherit CreationDate Site Date
               NavigationCaption VisibleInNavigation
               IsAppointment CanPayAppointment DurationAmount DurationUnit PriceListValues RatingAverage
               AmazonListerID AmazonCondition AmazonDeliveryLatency DownloadProductMaps PrepaymentType PrepaymentValue
               CustomizeAreaAllowPositioning CustomizeAreaAllowRotation CustomizeAreaAllowScaling CustomizeShowPreview CustomizeDescription
               ImageMedium ImageSmall ImageHotDeal ImageMediumSmall ImageMediumLarge

               IsDailyPrice EcoParticipationCategory TaxClassDigital OrderUnit PriceQuantity MinOrder IntervalOrder URI
               IsNew NewnessDate IsAvailable AvailabilityDate ExpiryDate AvailabilityComment IsBundleProduct IsDefault HasSubOwnPrices
               IsDownloadProduct MaxDownloadTime MaxDownloadCount Preview

         ) ],
    1 => [ qw( Class ListPrices SuperProduct SelectedVariations ManufacturerPrices ShippingMethods IsCustomizable) ],
};

#========================================================================================
# global       CSV_SPECIAL_PRODUCTITEMS_UNITY_IMP | csv import constants <ul>
#                   <li>0 - do not import this attributes</li>
#                   <li>1 - import this attributes, also if not exportable</li>
#               </ul> | ref.array.string
#========================================================================================
use constant CSV_SPECIAL_PRODUCTITEMS_UNITY_IMP => {
    0 => [ qw( GUID Inherit CreationDate Site Date
        NavigationCaption VisibleInNavigation
        IsAppointment CanPayAppointment DurationAmount DurationUnit PriceListValues RatingAverage
        AmazonListerID AmazonCondition AmazonDeliveryLatency DownloadProductMaps PrepaymentType PrepaymentValue
        CustomizeAreaAllowPositioning CustomizeAreaAllowRotation CustomizeAreaAllowScaling CustomizeShowPreview CustomizeDescription

    ) ],
    1 => [ qw( Class ListPrices SuperProduct SelectedVariations ManufacturerPrices ShippingMethods EcoParticipations Deposits) ],
};

#========================================================================================
# global       @UNITY_CSV_ATTRIBUTEVALUES_NOT_FOR_SUBPRODUCTS | csv export import constants for unity shops <ul>
#                   <li>do not export this attribute values for sub products of an unity shop</li>
#               </ul> | ref.array.string
#========================================================================================
use constant UNITY_CSV_ATTRIBUTEVALUES_NOT_FOR_SUBPRODUCTS => qw(
    Manufacturer
    );

use constant CSV_WARNING_CODES_PRODUCT => qw(
    NO_PRODUCTS
    VOID_FIELD
    VARIATION_EXISTS
    WRONG_PREDEF
    WRONG_PREDEF_VALUE
    PRODUCT_EMPTY_ALIAS
    NO_SUCH_PRODUCTCLASS
    NO_SUPER_PRODUCT
    WRONG_PRODUCTCLASS
    NO_PREDEF_ATTRIBUTE
    NO_PREDEF_VALUE
    NO_MAND_VALUE
    FeatureLimitExceeded
    SubProductsCountFeatureLimitExceeded
    SHORTURL_ALREADY_EXISTS
    SHORTURL_INVALID_CHARACTER
    SHORTURL_NOT_ALLOWED
    REFERENCED_IMAGE_MISSING
    ONE_OR_MORE_REFERENCED_IMAGE_MISSING
    ONE_OR_MORE_REFERENCED_IMAGE_NOT_DOWNLOADABLE
    WRONG_ECOPARTICIPATIONCATEGORY
    MISSING_ECOPARTICIPATIONCATEGORY
    MISSING_FEATURE
    NAME_NOT_VALID
);

use constant CSV_WARNING_CODES_PRODUCTTYPE => qw(
    NO_MAND_VALUE
    WRONG_TEMPLATE
    FeatureLimitExceeded
    VariationFeatureLimitExceeded
    ATTRIBUTE_EXISTS
    WRONG_PRODUCTATTRIBUTE_TYPE
    VariationAttributeValuesFeatureLimitExceeded
);


# inheritable attributes form master product to sub products, if master attributes are changed
# used in hook function "DE_EPAGES::Product::Hooks::Product::OnAfterUpdateProduct"
use constant FROM_MASTERPRODUCT_INHERITABLE_ATTRIBUTES_ON_UPDATE => qw(
    IsVisible
    IsNew
    IsDailyPrice
    IsAvailable
);

use constant FROM_MASTERPRODUCT_NON_INHERITABLE_ATTRIBUTES_ON_GETWITHPARENT => qw(
    ListPrice
    ListPrices
    ChildObjects
    StockLevel
    _ProductDataSheet
    _EnergyLabelSourceFile
);

# attributes written to sub products if sub products are created and updated
# we have no API inheritance of this attributes
use constant UNITY_ATTRIBUTES_FROM_MASTERPRODUCT_WRITTEN_ON_SUBS_ON_CREATE => qw(
    Weight
    WeightUnit
    StockLevel
    StockLevelAlert
    UPCEAN
    Height
    Length
    Width
    OrderUnit
    MinOrder
    IntervalOrder
    PriceQuantity
    RefAmount
    RefContentAmount
    RefUnit
    DeliveryPeriod
    ManufacturerID
    ManufacturerSKU
    TaxClass
    TaxClassMapping
);

# localized attributes written on sub products if sub products are created
# we have no API inheritance of this attributes
use constant UNITY_LOC_ATTRIBUTES_FROM_MASTERPRODUCT_WRITTEN_ON_SUBS_ON_CREATE => qw(
    Name
    Description
    MainCharacteristics
    Keywords
    Title
    Text
    ProductVideoProvider
    TaxClassMapping
    CustomizableHeadlineText
);

# this attributes are not updated on the sub products if changed on master
use constant UNITY_NOT_UPDATE_ATTRIBUTES_ON_SUBS_ON_UPDATE_MASTER => qw(
    Name
    Description
    MainCharacteristics
    Keywords
    Title
    Text
    ProductVideoProvider
    OrderUnit
    MinOrder
    IntervalOrder
    PriceQuantity
    DeliveryPeriod
    Height
    Length
    Width
    ManufacturerSKU
    EnergyLabelHighestEfficiencyClass
    EnergyLabelsString
    StockLevel
    StockLevelAlert
    Weight
    WeightUnit
    UPCEAN
    IsVisible
    RefAmount
    RefContentAmount
    RefUnit
    TaxClass
    TaxClassMapping
);

# these attributes are inherited from the master product
# to avoid a duplication of the related files
use constant UNITY_INHERITABLE_ATTRIBUTES => qw(
    EnergyLabelHighestEfficiencyClass
    EnergyLabelsString
);

# this attributes are not updated on the sub products if changed on master
use constant UNITY_IMAGE_ATTRIBUTES => qw(
    ImageHotDeal
    ImageLarge
    ImageMedium
    ImageMediumLarge
    ImageMediumSmall
    ImageSmall
    ImageThumbnail
    ImagesSlideShowString
);

# this attributes are not exported or imported for producttypes
use constant UNITY_PRODUCT_TYPE_ATTRIBUTES_IGNORE => qw(
    IsHTML
    Description
    ShowInOwnTab
    IsSearchFilter
    Content-Base
    Content-Variation
    Content-Bundles
);

# used by product type webservice
use constant PRODUCT_PAGETYPE => 'SF-Product';

use constant PRODUCT_ATTRIBUTE_TYPES => {
    'String'                     => {'Package' => 'DE_EPAGES::Object::API::Attributes::DefaultAttribute',   'IsObject' => 0},
    'LocalizedString'            => {'Package' => 'DE_EPAGES::Object::API::Attributes::LocalizedAttribute', 'IsObject' => 0},
    'PreDefString'               => {'Package' => 'DE_EPAGES::Object::API::Attributes::PreDefined',         'IsObject' => 1},
    'PreDefLocalizedString'      => {'Package' => 'DE_EPAGES::Object::API::Attributes::PreDefined',         'IsObject' => 1},
    'PreDefMultiString'          => {'Package' => 'DE_EPAGES::Object::API::Attributes::PreDefMulti',        'IsObject' => 0},
    'PreDefMultiLocalizedString' => {'Package' => 'DE_EPAGES::Object::API::Attributes::PreDefMulti',        'IsObject' => 0},
    'PreDefCustomerString'       => {'Package' => 'DE_EPAGES::Object::API::Attributes::PreDefMulti',        'IsObject' => 0},
    'Integer'                    => {'Package' => 'DE_EPAGES::Object::API::Attributes::DefaultAttribute',   'IsObject' => 0},
    'Float'                      => {'Package' => 'DE_EPAGES::Object::API::Attributes::DefaultAttribute',   'IsObject' => 0},
    'Boolean'                    => {'Package' => 'DE_EPAGES::Object::API::Attributes::DefaultAttribute',   'IsObject' => 0},
    'Money'                      => {'Package' => 'DE_EPAGES::Object::API::Attributes::DefaultAttribute',   'IsObject' => 0},
    'DateTime'                   => {'Package' => 'DE_EPAGES::Object::API::Attributes::DefaultAttribute',   'IsObject' => 0},
    'Date'                       => {'Package' => 'DE_EPAGES::Object::API::Attributes::DefaultAttribute',   'IsObject' => 0},
    'Time'                       => {'Package' => 'DE_EPAGES::Object::API::Attributes::DefaultAttribute',   'IsObject' => 0},
    'File'                       => {'Package' => 'DE_EPAGES::Object::API::Attributes::DefaultAttribute',   'IsObject' => 0},
    'LocalizedFile'              => {'Package' => 'DE_EPAGES::Object::API::Attributes::LocalizedAttribute', 'IsObject' => 0},
};

#========================================================================================
# global   PRODUCT_IMAGES_SIZES
#           | image dimensions for automatic resizing. Hash key
#             is the image size postfix ('s'=small, 'm'=medium, 'l'=large, 'h'=huge, 'xs'=thumbnail).
#             Hash value is the image size as array reference [width, height].
#           | ref.hash.array.int
# example  my ($dx, $dy) = @{ PRODUCT_IMAGES_SIZES->{'xs'} }
#========================================================================================
use constant PRODUCT_IMAGES_SIZES => {
    's'  => [ 100,  100],
    'ms' => [ 200,  200],
    'm'  => [ 500,  500],
    'ml' => [1000, 1000],
    'l'  => [ 800,  600], #now dynamic via shop attribute!
    'h'  => [ 150,  150],
    'xs' => [  50,   33],
};

#========================================================================================
# global   PRODUCT_LARGE_IMAGE_SIZES
#           | image dimensions for automatic resizing of the large product image.
#           | ref.array.string
# example  my @Sizes = @{ PRODUCT_LARGE_IMAGE_SIZES }
#========================================================================================
use constant PRODUCT_LARGE_IMAGE_SIZES => [
    '1024 x 768',
    '1280 x 1024',
    '1680 x 1050',
    '1920 x 1080',
];

#========================================================================================
# global   PRODUCT_IMAGE_SIZE_NAMES
#           | maps image size postfix (see PRODUCT_IMAGES_SIZES)
#             to product attribut name, for example 'xs' => 'ImageThumbnail'.
#           | ref.hash.string
# example  my ($dx, $dy) = @{ PRODUCT_IMAGES_SIZES->{'xs'} }
#========================================================================================
use constant PRODUCT_IMAGE_SIZE_NAMES => {
    's'     => 'ImageSmall',
    'm'     => 'ImageMedium',
    'ms'    => 'ImageMediumSmall',
    'ml'    => 'ImageMediumLarge',
    'l'     => 'ImageLarge',
    'h'     => 'ImageHotDeal',
    'xs'    => 'ImageThumbnail'
};

#========================================================================================
# global   PRODUCT_IMAGES_JPEG_QUALITIES | Quality value for JPEG images, 0 - 100 | integer
#           | ref.hash.string
# example  my $quality = @{ PRODUCT_JPEG_QUALITIES->{'m'} }
#========================================================================================
use constant PRODUCT_IMAGES_JPEG_QUALITIES => {
    'm'     => 30,
    'ml'    => 30,
};

use constant PRODUCT_IMAGE_MAX_COUNT => 100;

use constant SMART_PRODUCT_SEARCH_RESULT_COUNT => 10;

use constant CONVERSION_FACTOR_BYTE => 1024;

#========================================================================================
# global   PRODUCT_ATTRIBUTE_DEPENDENCY
#           | maps a product attribute to another on which it depends
#           | ref.hash.string
# example  my $AttributeName = PRODUCT_ATTRIBUTE_DEPENDENCY->{'DependendAttributeName'}
#========================================================================================
use constant PRODUCT_ATTRIBUTE_DEPENDENCY => {
    'RefUnit'     => 'RefAmount',
    'WeightUnit'  => 'Weight',
    'EcoParticipationCategory' => 'EcoParticipations',
};

sub MBOUI_PRODUCT_DETAIL_PAGE { ## no critic qw(RequireCommentForExportedFunctions) # not public
    return [
        { 'IsSectionVisible'=>'1', 'Position'=>'0', 'alias'=>'Name', 'id'=>'MBOUI_ProductDetailPage' },
        { 'IsSectionVisible'=>'1', 'Position'=>'1', 'alias'=>'Price', 'id'=>'MBOUI_ProductDetailPage' },
        { 'IsSectionVisible'=>'0', 'Position'=>'2', 'alias'=>'Quantity', 'id'=>'MBOUI_ProductDetailPage' },
        { 'IsSectionVisible'=>'1', 'Position'=>'3', 'alias'=>'Description', 'id'=>'MBOUI_ProductDetailPage' },
        { 'IsSectionVisible'=>'1', 'Position'=>'4', 'alias'=>'Sale', 'id'=>'MBOUI_ProductDetailPage' },
        { 'IsSectionVisible'=>'1', 'Position'=>'5', 'alias'=>'Manufacturer', 'id'=>'MBOUI_ProductDetailPage' },
        { 'IsSectionVisible'=>'1', 'Position'=>'6', 'alias'=>'Stock', 'id'=>'MBOUI_ProductDetailPage' },
        { 'IsSectionVisible'=>'0', 'Position'=>'7', 'alias'=>'Delivery', 'id'=>'MBOUI_ProductDetailPage' },
        { 'IsSectionVisible'=>'1', 'Position'=>'8', 'alias'=>'Attribute', 'id'=>'MBOUI_ProductDetailPage' },
    ];
}

# Vimeo API url for getting video information
use constant VIMEO_API_URL => 'http://vimeo.com/api/v2/video/[videoid].json';

# Max. length for headline for customizable products
use constant UNITY_CUSTOMIZABLE_HEADLINELENGTH => 25;

# Default value for textlength for customizable products
use constant UNITY_CUSTOMIZABLE_DEFAULTTEXTLENGTH => 50;

1;
